"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStorage = exports.useToggle = exports.useViewportState = exports.useEvent = exports.useSearchQuery = exports.useQueryParams = exports.useQueryParam = exports.useInfiniteScroll = exports.useConditionalTimeout = exports.useSwipeEvents = exports.useVerticalSwipe = exports.useHorizontalSwipe = exports.useSwipe = exports.useRenderInfo = exports.useSystemVoices = exports.useSpeechSynthesis = exports.useObservable = exports.useDefaultedState = exports.useResizeObserver = exports.useSessionStorage = exports.useLocalStorage = exports.useRequestAnimationFrame = exports.useDropZone = exports.useDrag = exports.useDragEvents = exports.useValidatedState = exports.useViewportSpy = exports.useOnlineState = exports.useValueHistory = exports.useMediaQuery = exports.useGeolocationState = exports.useGeolocationEvents = exports.useGeolocation = exports.usePreviousValue = exports.useGlobalEvent = exports.useInterval = exports.useTimeout = exports.useMouseState = exports.useMouseEvents = exports.useMouse = exports.useThrottledCallback = exports.useDebouncedCallback = exports.useWindowScroll = exports.useWindowResize = exports.useLifecycle = exports.useWillUnmount = exports.useDidMount = void 0;
/**
 * This file is kept for compatibility reasons.
 * You should avoid importing hooks directly from this file.
 *
 * Avoid importing hooks like this:
 *
 * ```js
 * import { useSomething } from 'beautiful-react-hooks';
 * ```
 *
 * in favour of this:
 *
 * ```js
 * import useSomething from 'beautiful-react-hooks/useSomething';
 * ```
 */
var useDidMount_1 = require("./useDidMount");
Object.defineProperty(exports, "useDidMount", { enumerable: true, get: function () { return __importDefault(useDidMount_1).default; } });
var useWillUnmount_1 = require("./useWillUnmount");
Object.defineProperty(exports, "useWillUnmount", { enumerable: true, get: function () { return __importDefault(useWillUnmount_1).default; } });
var useLifecycle_1 = require("./useLifecycle");
Object.defineProperty(exports, "useLifecycle", { enumerable: true, get: function () { return __importDefault(useLifecycle_1).default; } });
var useWindowResize_1 = require("./useWindowResize");
Object.defineProperty(exports, "useWindowResize", { enumerable: true, get: function () { return __importDefault(useWindowResize_1).default; } });
var useWindowScroll_1 = require("./useWindowScroll");
Object.defineProperty(exports, "useWindowScroll", { enumerable: true, get: function () { return __importDefault(useWindowScroll_1).default; } });
var useDebouncedCallback_1 = require("./useDebouncedCallback");
Object.defineProperty(exports, "useDebouncedCallback", { enumerable: true, get: function () { return __importDefault(useDebouncedCallback_1).default; } });
var useThrottledCallback_1 = require("./useThrottledCallback");
Object.defineProperty(exports, "useThrottledCallback", { enumerable: true, get: function () { return __importDefault(useThrottledCallback_1).default; } });
var useMouse_1 = require("./useMouse");
Object.defineProperty(exports, "useMouse", { enumerable: true, get: function () { return __importDefault(useMouse_1).default; } });
var useMouseEvents_1 = require("./useMouseEvents");
Object.defineProperty(exports, "useMouseEvents", { enumerable: true, get: function () { return __importDefault(useMouseEvents_1).default; } });
var useMouseState_1 = require("./useMouseState");
Object.defineProperty(exports, "useMouseState", { enumerable: true, get: function () { return __importDefault(useMouseState_1).default; } });
var useTimeout_1 = require("./useTimeout");
Object.defineProperty(exports, "useTimeout", { enumerable: true, get: function () { return __importDefault(useTimeout_1).default; } });
var useInterval_1 = require("./useInterval");
Object.defineProperty(exports, "useInterval", { enumerable: true, get: function () { return __importDefault(useInterval_1).default; } });
var useGlobalEvent_1 = require("./useGlobalEvent");
Object.defineProperty(exports, "useGlobalEvent", { enumerable: true, get: function () { return __importDefault(useGlobalEvent_1).default; } });
var usePreviousValue_1 = require("./usePreviousValue");
Object.defineProperty(exports, "usePreviousValue", { enumerable: true, get: function () { return __importDefault(usePreviousValue_1).default; } });
var useGeolocation_1 = require("./useGeolocation");
Object.defineProperty(exports, "useGeolocation", { enumerable: true, get: function () { return __importDefault(useGeolocation_1).default; } });
var useGeolocationEvents_1 = require("./useGeolocationEvents");
Object.defineProperty(exports, "useGeolocationEvents", { enumerable: true, get: function () { return __importDefault(useGeolocationEvents_1).default; } });
var useGeolocationState_1 = require("./useGeolocationState");
Object.defineProperty(exports, "useGeolocationState", { enumerable: true, get: function () { return __importDefault(useGeolocationState_1).default; } });
var useMediaQuery_1 = require("./useMediaQuery");
Object.defineProperty(exports, "useMediaQuery", { enumerable: true, get: function () { return __importDefault(useMediaQuery_1).default; } });
var useValueHistory_1 = require("./useValueHistory");
Object.defineProperty(exports, "useValueHistory", { enumerable: true, get: function () { return __importDefault(useValueHistory_1).default; } });
var useOnlineState_1 = require("./useOnlineState");
Object.defineProperty(exports, "useOnlineState", { enumerable: true, get: function () { return __importDefault(useOnlineState_1).default; } });
var useViewportSpy_1 = require("./useViewportSpy");
Object.defineProperty(exports, "useViewportSpy", { enumerable: true, get: function () { return __importDefault(useViewportSpy_1).default; } });
var useValidatedState_1 = require("./useValidatedState");
Object.defineProperty(exports, "useValidatedState", { enumerable: true, get: function () { return __importDefault(useValidatedState_1).default; } });
var useDragEvents_1 = require("./useDragEvents");
Object.defineProperty(exports, "useDragEvents", { enumerable: true, get: function () { return __importDefault(useDragEvents_1).default; } });
var useDrag_1 = require("./useDrag");
Object.defineProperty(exports, "useDrag", { enumerable: true, get: function () { return __importDefault(useDrag_1).default; } });
var useDropZone_1 = require("./useDropZone");
Object.defineProperty(exports, "useDropZone", { enumerable: true, get: function () { return __importDefault(useDropZone_1).default; } });
var useRequestAnimationFrame_1 = require("./useRequestAnimationFrame");
Object.defineProperty(exports, "useRequestAnimationFrame", { enumerable: true, get: function () { return __importDefault(useRequestAnimationFrame_1).default; } });
var useLocalStorage_1 = require("./useLocalStorage");
Object.defineProperty(exports, "useLocalStorage", { enumerable: true, get: function () { return __importDefault(useLocalStorage_1).default; } });
var useSessionStorage_1 = require("./useSessionStorage");
Object.defineProperty(exports, "useSessionStorage", { enumerable: true, get: function () { return __importDefault(useSessionStorage_1).default; } });
var useResizeObserver_1 = require("./useResizeObserver");
Object.defineProperty(exports, "useResizeObserver", { enumerable: true, get: function () { return __importDefault(useResizeObserver_1).default; } });
var useDefaultedState_1 = require("./useDefaultedState");
Object.defineProperty(exports, "useDefaultedState", { enumerable: true, get: function () { return __importDefault(useDefaultedState_1).default; } });
var useObservable_1 = require("./useObservable");
Object.defineProperty(exports, "useObservable", { enumerable: true, get: function () { return __importDefault(useObservable_1).default; } });
var useSpeechSynthesis_1 = require("./useSpeechSynthesis");
Object.defineProperty(exports, "useSpeechSynthesis", { enumerable: true, get: function () { return __importDefault(useSpeechSynthesis_1).default; } });
var useSystemVoices_1 = require("./useSystemVoices");
Object.defineProperty(exports, "useSystemVoices", { enumerable: true, get: function () { return __importDefault(useSystemVoices_1).default; } });
var useRenderInfo_1 = require("./useRenderInfo");
Object.defineProperty(exports, "useRenderInfo", { enumerable: true, get: function () { return __importDefault(useRenderInfo_1).default; } });
var useSwipe_1 = require("./useSwipe");
Object.defineProperty(exports, "useSwipe", { enumerable: true, get: function () { return __importDefault(useSwipe_1).default; } });
var useHorizontalSwipe_1 = require("./useHorizontalSwipe");
Object.defineProperty(exports, "useHorizontalSwipe", { enumerable: true, get: function () { return __importDefault(useHorizontalSwipe_1).default; } });
var useVerticalSwipe_1 = require("./useVerticalSwipe");
Object.defineProperty(exports, "useVerticalSwipe", { enumerable: true, get: function () { return __importDefault(useVerticalSwipe_1).default; } });
var useSwipeEvents_1 = require("./useSwipeEvents");
Object.defineProperty(exports, "useSwipeEvents", { enumerable: true, get: function () { return __importDefault(useSwipeEvents_1).default; } });
var useConditionalTimeout_1 = require("./useConditionalTimeout");
Object.defineProperty(exports, "useConditionalTimeout", { enumerable: true, get: function () { return __importDefault(useConditionalTimeout_1).default; } });
var useInfiniteScroll_1 = require("./useInfiniteScroll");
Object.defineProperty(exports, "useInfiniteScroll", { enumerable: true, get: function () { return __importDefault(useInfiniteScroll_1).default; } });
var useQueryParam_1 = require("./useQueryParam");
Object.defineProperty(exports, "useQueryParam", { enumerable: true, get: function () { return __importDefault(useQueryParam_1).default; } });
var useQueryParams_1 = require("./useQueryParams");
Object.defineProperty(exports, "useQueryParams", { enumerable: true, get: function () { return __importDefault(useQueryParams_1).default; } });
var useSearchQuery_1 = require("./useSearchQuery");
Object.defineProperty(exports, "useSearchQuery", { enumerable: true, get: function () { return __importDefault(useSearchQuery_1).default; } });
var useEvent_1 = require("./useEvent");
Object.defineProperty(exports, "useEvent", { enumerable: true, get: function () { return __importDefault(useEvent_1).default; } });
var useViewportState_1 = require("./useViewportState");
Object.defineProperty(exports, "useViewportState", { enumerable: true, get: function () { return __importDefault(useViewportState_1).default; } });
var useToggle_1 = require("./useToggle");
Object.defineProperty(exports, "useToggle", { enumerable: true, get: function () { return __importDefault(useToggle_1).default; } });
// keep it just for compatibility issues
var createStorageHook_1 = require("./factory/createStorageHook");
Object.defineProperty(exports, "useStorage", { enumerable: true, get: function () { return __importDefault(createStorageHook_1).default; } });
