import { RefObject } from 'react';
import { UseSwipeOptions } from './useSwipe';
/**
 * A shortcut to useSwipe (with vertical options)
 * @param ref
 * @param options
 * @return {{alpha: number, count: number, swiping: boolean, direction: null}}
 */
declare const useVerticalSwipe: <TElement extends HTMLElement>(ref?: RefObject<TElement>, options?: UseSwipeOptions) => {
    swiping: boolean;
    direction?: import("./shared/swipeUtils").Direction;
    alphaX: number;
    alphaY: number;
    count: number;
};
export default useVerticalSwipe;
